nx_server_plugin_sdk 1.0 Server Plugin SDK

Public Member Functions | Protected Attributes | List of all members
TestIODevice Class Reference
Inheritance diagram for TestIODevice:

## Public Member Functions
| TestIODevice (const std::string &name, FileCategory category, int mode, int64_t size=0, FILE *f=nullptr)
virtual uint32_t STORAGE_METHOD_CALL | write (const void *src, const uint32_t size, int *ecode) override
virtual uint32_t STORAGE_METHOD_CALL | read (void *dst, const uint32_t size, int *ecode) const override
virtual int STORAGE_METHOD_CALL | getMode () const override
virtual uint32_t STORAGE_METHOD_CALL | size (int *ecode) const override
virtual int STORAGE_METHOD_CALL | seek (uint64_t pos, int *ecode) override
virtual void * | queryInterface (const nxpl::NX_GUID &interfaceID) override
| Cast to type, specified by interfaceID. More...
virtual int | addRef () const override
| Increment reference counter. More...
virtual int | releaseRef () const override
| Decrement reference counter. More...
Public Member Functions inherited from PluginRefCounter< TestIODevice >
int | pAddRef () const
int | pReleaseRef () const

## Protected Attributes
const std::string | m_sampleFileName

## Member Function Documentation

## ◆ addRef()

int TestIODevice::addRef | ( |  | ) | const
| overridevirtual

Increment reference counter.

Returns
  new reference count

Note
  PluginInterface::releaseRef is not guaranteed to be called from thread that called PluginInterface::addRef

Implements nxpl::PluginInterface.

## ◆ getMode()

int TestIODevice::getMode | ( |  | ) | const
| overridevirtual

Returns
  IOMode

Implements nx_spl::IODevice.

## ◆ queryInterface()

void * TestIODevice::queryInterface | ( | const nxpl::NX_GUID & | interfaceID | ) |
| overridevirtual

Cast to type, specified by interfaceID.

If pointer cannot be cast, NULL MUST be returned

Returns
  If not NULL, returned pointer can be safely cast to type, defined by interfaceID

Note
  This method increments reference counter

Implements nxpl::PluginInterface.

## ◆ read()

uint32_t TestIODevice::read | ( | void * | dst,
|  | const uint32_t | size,
|  | int * | ecode
| ) |  | const
| overridevirtual

reads data from device to dst pointer

Parameters

  dst | pointer to user buffer
  size | read size (bytes)
  ecode | Pointer to error code. Pass NULL if you are not interested in error information.

Returns
  bytes read.

Implements nx_spl::IODevice.

## ◆ releaseRef()

int TestIODevice::releaseRef | ( |  | ) | const
| overridevirtual

Decrement reference counter.

When zero, object MUST be removed

Returns
  new reference count

Note
  PluginInterface::releaseRef is not guaranteed to be called from thread that called PluginInterface::addRef

Implements nxpl::PluginInterface.

## ◆ seek()

int TestIODevice::seek | ( | uint64_t | pos,
|  | int * | ecode
| ) |  |
| overridevirtual

Parameters

  pos | seek position
  ecode | Pointer to error code. Pass NULL if you are not interested in error information.

Returns
  success (0,1)

Implements nx_spl::IODevice.

## ◆ size()

uint32_t TestIODevice::size | ( | int * | ecode | ) | const
| overridevirtual

Parameters

  ecode | Pointer to error code. Pass NULL if you are not interested in error information.

Returns
  available (read) size of device

Implements nx_spl::IODevice.

## ◆ write()

uint32_t TestIODevice::write | ( | const void * | src,
|  | const uint32_t | size,
|  | int * | ecode
| ) |  |
| overridevirtual

Parameters

  src | source data
  size | write size (bytes)
  ecode | Pointer to error code. Pass NULL if you are not interested in error information.

Returns
  bytes written.

Implements nx_spl::IODevice.

The documentation for this class was generated from the following files:

- samples/storage/test_storage_plugin/src/test_io_device.h
- samples/storage/test_storage_plugin/src/test_io_device.cpp